package org.simantics.db.layer0.util;

import java.util.Collection;
import java.util.Map;

import org.simantics.db.RequestProcessor;
import org.simantics.db.Resource;
import org.simantics.db.layer0.util.SimanticsClipboard.Representation;
import org.simantics.utils.datastructures.hints.IHintContext.Key;

class ResourceCopyRepresentation implements Representation {

    private Collection<Resource> resources;

    public ResourceCopyRepresentation(Collection<Resource> resources) {
        this.resources = resources;
    }

    @Override
    public Key getKey() {
        return SimanticsKeys.KEY_COPY_RESOURCES;
    }

    @SuppressWarnings("unchecked")
    @Override
    public <T> T getValue(RequestProcessor processor, Map<String,Object> hints) {
        return (T) resources;
    }

}